codeunit 50016 DynamicwebCustomHelper
{
    procedure AddCustomElement(elementName: Text; elementValue: Text; attributes: XmlAttributeCollection; var responseRootNode: XmlNode);
    var
        pXmlElement: XmlElement;
        attr: XmlAttribute;
    begin
        pXmlElement := XmlElement.Create(elementName);
        pXmlElement.Add(XmlText.Create(elementValue));
        foreach attr in attributes do begin
            pXmlElement.SetAttribute(attr.Name, attr.Value);
        end;
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;

    procedure AddCustomElement(elementName: Text; var responseRootNode: XmlNode);
    var
        pXmlElement: XmlElement;
    begin
        pXmlElement := XmlElement.Create(elementName);
        pXmlElement.Add(XmlText.Create('hello'));
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;

    procedure AddCustomElement(elementName: Text; var responseDoc: XmlDocument);
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        pXmlElement := XmlElement.Create(elementName);
        pXmlElement.Add(XmlText.Create('hello'));
        responseDoc.GetRoot(xmlRoot);
        xmlRoot.Add(pXmlElement);
    end;


    procedure AddElement(var pXmlNode: XmlNode; pNodeName: Text; pNodeText: Text; pNameSpace: Text; var pCreatedNode: XmlNode): Boolean
    begin
        IF pNodeText <> '' then
            pCreatedNode := XmlElement.Create(pNodeName, pNameSpace, pNodeText).AsXmlNode
        else
            pCreatedNode := XmlElement.Create(pNodeName, pNameSpace).AsXmlNode;
        Exit(pXmlNode.AsXmlElement.Add(pCreatedNode));
    end;

    procedure AddCdataElement(var pXmlNode: XmlNode; NodeText: Text)
    begin
        pXmlNode.AsXmlElement.Add(XmlCData.Create(NodeText));
    end;

    procedure AddAttribute(var pXmlNode: XmlNode; Name: Text; NodeValue: Text);
    begin
        pXmlNode.AsXmlElement.SetAttribute(Name, NodeValue);
    end;

    procedure AddField(var pXmlNode: XmlNode; Name: Text; Value: Text);
    var
        XmlNewChild: XmlNode;
    begin
        AddElement(pXmlNode, 'column', '', '', XmlNewChild);
        AddAttribute(XmlNewChild, 'columnName', Name);
        AddCdataElement(XmlNewChild, Value);
    end;
}