/// <summary>
/// Represents global notifications subscribers
/// </summary>
codeunit 50010 DynamicwebGlobalSubscriber
{
    EventSubscriberInstance = StaticAutomatic;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebPublisher, 'OnBeforeExecuteRequest', '', true, true)]
    procedure OnBeforeExecuteRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseDoc: XmlDocument)
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        // Modify request xml to your needs
        requestDoc.GetRoot(xmlRoot);
        xmlRoot.Attributes().Set('test', 'value');

        // Set stopExecution to cancel base application processing the request        
        //stopExecution := true;

        // If stopExecution set to true you can Set custom xml for the response output        
        // otherwise base app will return its output
        //pXmlElement := XmlElement.Create('OnBeforeExecuteRequest');
        //pXmlElement.Add(XmlText.Create('hello'));
        //XmlDocument.ReadFrom('<?xml version="1.0" encoding="utf-8" ?><tables/>', responseDoc);
        //responseDoc.GetRoot(xmlRoot);
        //xmlRoot.Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebPublisher, 'OnAfterExecuteXmlRequest', '', true, true)]
    procedure OnAfterExecuteXmlRequest(var requestDoc: XmlDocument; var responseDoc: XmlDocument)
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        // Add custom xml for the response output        
        pXmlElement := XmlElement.Create('OnAfterExecuteXmlRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseDoc.GetRoot(xmlRoot);
        xmlRoot.Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebPublisher, 'OnAfterExecutePdfRequest', '', true, true)]
    procedure OnAfterExecutePdfRequest(var requestDoc: XmlDocument; var response: BigText);
    begin
        Clear(response);
        response.AddText('OnAfterExecutePdfRequest: This is custom pdf string');
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebPublisher, 'OnBeforeSendXmlResponse', '', true, true)]
    procedure OnBeforeSendXmlResponse(var requestDoc: XmlDocument; var responseDoc: XmlDocument);
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        // Add custom xml for the response output        
        pXmlElement := XmlElement.Create('OnBeforeSendXmlResponse');
        pXmlElement.Add(XmlText.Create('hello'));
        responseDoc.GetRoot(xmlRoot);
        xmlRoot.Add(pXmlElement);
    end;
}