codeunit 50013 DynamicwebUsersSubscriber
{
    EventSubscriberInstance = StaticAutomatic;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnBeforeGetCustomersRequest', '', true, true)]
    procedure OnBeforeGetCustomersRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    var
        pXmlElement: XmlElement;
    begin
        // Modify requestDoc request xml to your needs

        // Set stopExecution := true to cancel base application processing the request        
        // stopExecution := true;

        // If stopExecution set to true you can Set custom xml for the response output        
        // otherwise base app will append its output to responseDoc
        pXmlElement := XmlElement.Create('OnBeforeGetCustomersRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnAfterGetCustomersRequest', '', true, true)]
    procedure OnAfterGetCustomersRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        // Add custom xml for the response output        
        AddCustomElement(responseRootNode, 'OnAfterGetCustomersRequest');
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnBeforeGetContactsRequest', '', true, true)]
    procedure OnBeforeGetContactsRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    var
        pXmlElement: XmlElement;
    begin
        // Modify requestDoc request xml to your needs

        // Set stopExecution := true to cancel base application processing the request        
        // stopExecution := true;

        // If stopExecution set to true you can Set custom xml for the response output        
        // otherwise base app will append its output to responseDoc
        pXmlElement := XmlElement.Create('OnBeforeGetContactsRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnAfterGetContactsRequest', '', true, true)]
    procedure OnAfterGetContactsRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        // Add custom xml for the response output        
        AddCustomElement(responseRootNode, 'OnAfterGetContactsRequest');
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnBeforeGetAddressesRequest', '', true, true)]
    procedure OnBeforeGetAddressesRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    var
        pXmlElement: XmlElement;
    begin
        // Modify requestDoc request xml to your needs

        // Set stopExecution := true to cancel base application processing the request        
        // stopExecution := true;

        // If stopExecution set to true you can Set custom xml for the response output        
        // otherwise base app will append its output to responseDoc
        pXmlElement := XmlElement.Create('OnBeforeGetAddressesRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnAfterGetAddressesRequest', '', true, true)]
    procedure OnAfterGetAddressesRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        // Add custom xml for the response output        
        AddCustomElement(responseRootNode, 'OnAfterGetAddressesRequest');
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnBeforeExecutePutUsersRequest', '', true, true)]
    procedure OnBeforeExecutePutUsersRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseDoc: XmlDocument);
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        // Modify request xml to your needs
        requestDoc.GetRoot(xmlRoot);
        xmlRoot.Attributes().Set('test', 'value');

        // // Set stopExecution to cancel base application processing the request        
        // stopExecution := true;

        // // If stopExecution set to true you can Set custom xml for the response output        
        // otherwise base app will append its output to responseDoc
        pXmlElement := XmlElement.Create('OnBeforeExecutePutUsersRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseDoc.GetRoot(xmlRoot);
        xmlRoot.Add(pXmlElement);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebUsersPublisher, 'OnAfterExecutePutUsersRequest', '', true, true)]
    procedure OnAfterExecutePutUsersRequest(var requestDoc: XmlDocument; var responseDoc: XmlDocument);
    var
        pXmlElement: XmlElement;
        xmlRoot: XmlElement;
    begin
        // Add custom xml for the response output        
        pXmlElement := XmlElement.Create('OnAfterExecutePutUsersRequest');
        pXmlElement.Add(XmlText.Create('hello'));
        responseDoc.GetRoot(xmlRoot);
        xmlRoot.Add(pXmlElement);
    end;

    local procedure AddCustomElement(var responseRootNode: XmlNode; elementName: Text);
    var
        pXmlElement: XmlElement;
    begin
        // Add custom xml for the response output        
        pXmlElement := XmlElement.Create(elementName);
        pXmlElement.Add(XmlText.Create('hello'));
        responseRootNode.AsXmlElement().Add(pXmlElement);
    end;
}